Strict
'=============================== TYPES =============================
'------------------------------ Gegner -----------------------------
Type Gegner
	'Fields
	Field x:Float,y:Float,xs:Float,ys:Float
	Field bt:Int,b:Byte
	Field r:Byte,lastKF:KIKommandoFeld
	Field LP:Float,Typ:Byte
	
	Method Update()
		If ys=0 Then
			'Kommandos bertragen
			Local K:KIKommandoFeld
			For K=EachIn KommandoFeldList
				If RectsOverlap(x,y,32,48,K.x,K.y,K.w,K.h) And K<>lastKF Then
					lastKF=K
					Select K.Kommando
						Case 1
							r=0
						Case 2
							r=1
						Case 3
							ys=-7.5
						Case 4
							If Rand(100)>60 Then
								ys=-7.5
							Else
								r=0
							EndIf
						Case 5
							If Rand(100)>60 Then
								ys=-7.5
							Else
								r=1
							EndIf
						Case 6
							If Rand(100)>50 Then
								r=0
							Else
								r=1
							EndIf
					End Select
				EndIf
			Next
			'Animation der Beine etc.
			If bt<MilliSecs() Then
				b=b+1
				bt=MilliSecs()+75
				If b=7 Then b=3
			EndIf
		Else
			b=0
		EndIf
		
		'Geschwindigkeit in x-Richtung
		If r=0 And ys=0 And xs>-3.5 Then xs:-0.5
		If r=1 And ys=0 And xs<3.5 Then xs:+0.5
		
		If ys<>0 And xs<0 Then xs:+0.025
		If ys<>0 And xs>0 Then xs:-0.025
		
		'Geschwindigkeit in y-Richtung
		ys:+0.5
		
		'Kollisionsabfrage
		For Local ix:Int=Floor(x/32)-1 To Floor(x/32)+2
			For Local iy:Int=Floor(y/32)-1 To Floor(y/32)+2
				If ix>=0 And iy>=0 And ix<=MapWidth And iy<=MapHeight Then
					If Map[ix,iy]=1 Then
						If RectsOverlap(x+1,y+48,30,ys,ix*32,iy*32,32,32) And ys>0 Then ys=(y+48-iy*32)*-1
						If RectsOverlap(x+32,y+1,xs,46,ix*32,iy*32,32,32) And xs>0 Then xs=(x+32-ix*32)*-1
						If RectsOverlap(x-Abs(xs),y+1,Abs(xs),46,ix*32,iy*32,32,32) And xs<0 Then xs=(ix*32+32)-x
						If RectsOverlap(x+1,y-Abs(ys),30,Abs(ys),ix*32,iy*32,32,32) And ys<0 Then ys=(iy*32+32)-y
					EndIf
				EndIf
			Next
		Next
		
		'Gegner wird bewegt
		x:+xs
		y:+ys
		
		'Gegner wird besiegt
		If LP<1 Then 
			Local Random=Rand(15,30)
			For Local i=2 To Random
				Blutlist.AddLast(Blut.Create(x+16,y+24))
			Next
			Geld:+10+Typ*5
			Gegnerlist.Remove(Self)
		EndIf
		
		'Gegner entkam
		If x>(MapWidth+1)*32 Then
			Leben:-1
			LAbEffekt=255
			Gegnerlist.Remove(Self)
		EndIf
		
	End Method
	
	'Zeichnen des Gegners
	Method Draw()
		If x-ScrollX>-32 And x-ScrollX<WWidth+32 And y-ScrollY>-32 And y-ScrollY<WHeight+32 Then
			If Typ<=50 Then 
				SetColor 0+Typ*25.5,255-Typ*25.5,0
			Else
				SetColor 255,0,0
			EndIf
			If r=0 Then DrawImage Stickman,x-ScrollX,y-ScrollY,b
			If r=1 Then DrawImage StickmanR,x-ScrollX,y-ScrollY,b
		EndIf
	End Method
	
	'Erstellen des Gegners
	Function Create:Gegner(x:Float,y:Float,Typ:Byte)
		Local G:Gegner=New Gegner
		G.x=x
		G.y=y
		G.Typ=Typ
		G.b=1
		G.LP=1+2.1^Typ
		Return G
	End Function
End Type

'------------------------------ Trme ------------------------------

Type Turm
	Field x:Int,y:Int,Typ:Byte,Range:Short
	Field Winkel:Int,Ziel:Gegner,Cooldown:Int
	
	Method Update()
		Ziel=Null
		Local Weite:Int
		Weite=Range
		For Local G:Gegner=EachIn Gegnerlist
			If Sqr((G.x - x)^2 + (G.y - y)^2)<Weite Then
				Ziel=G
				Weite=Sqr((G.x - x)^2 + (G.y - y)^2)
			EndIf
		Next
		If Ziel<>Null Then Winkel=ATan2(Ziel.x+16-x+16,(Ziel.y-y+16)*-1)+90
		
		If Cooldown<MilliSecs() Then
			If Ziel<>Null Then
				If Typ=1 Then 
					Cooldown=MilliSecs()+125
					Schusslist.Addlast(Schuss.Create(x+16,y+16,winkel*-1-90,5,1))
				ElseIf Typ=2 Then 
					Cooldown=MilliSecs()+75
					Schusslist.Addlast(Schuss.Create(x+16,y+16,winkel*-1-90,5,2))
				ElseIf Typ=3 Then 
					Cooldown=MilliSecs()+100
					Schusslist.Addlast(Schuss.Create(x+16,y+16,winkel*-1-90,5,3))
				ElseIf Typ=4 Then 
					Cooldown=MilliSecs()+75
					Schusslist.Addlast(Schuss.Create(x+16,y+16,winkel*-1-90,5,4))
				ElseIf Typ=5 Then 
					Cooldown=MilliSecs()+50
					Schusslist.Addlast(Schuss.Create(x+16,y+16,winkel*-1-90,5,5))
				EndIf
			EndIf
		EndIf
	End Method
	
	Method Draw()
		If x+16-ScrollX>-32 And x+16-ScrollX<WWidth+32 And y+16-ScrollY>-32 And y+16-ScrollY<WHeight+32 Then
			SetColor 255,255,255
			AutoMidHandle 1
			SetRotation Winkel
			If Typ=1 Then
				DrawImage G1,x+16-ScrollX,y+16-ScrollY
			ElseIf Typ=2 Then
				DrawImage G2,x+16-ScrollX,y+16-ScrollY
			ElseIf Typ=3 Then
				DrawImage G3,x+16-ScrollX,y+16-ScrollY
			ElseIf Typ=4 Then
				DrawImage G4,x+16-ScrollX,y+16-ScrollY
			ElseIf Typ=5 Then
				DrawImage G5,x+16-ScrollX,y+16-ScrollY
			EndIf
			SetRotation 0
		EndIf
	End Method
	
	Function Create:Turm(x:Short,y:Short,Typ:Byte)
		Local T:Turm=New Turm
		T.x=x
		T.y=y
		T.Typ=Typ
		If Typ=1 Then T.Range=100
		If Typ=2 Then T.Range=120
		If Typ=3 Then T.Range=150
		If Typ=4 Then T.Range=200
		If Typ=5 Then T.Range=250
		Return T
	End Function
End Type

'----------------------------Schsse----------------------------------
Type Schuss
	Field x:Float,y:Float,winkel:Int,spd:Float,Typ:Byte
	
	Method Update()
		x:+Sin(winkel)*spd
		y:+Cos(winkel)*spd
		
		If x<=0 Or x>=(MapWidth+1)*32 Or y<=0 Or y>=(MapHeight+1)*32 Then 
			Schusslist.Remove(Self)
		Else
			If Map[Floor(x/32),Floor(y/32)]=1 Then
				Schusslist.Remove(Self)
			Else
				For Local G:Gegner=EachIn Gegnerlist
					If RectsOverlap(x,y,1,1,G.x,G.y,32,48) Then
						Local Random=Rand(3,5)
						For Local i=2 To Random
							Blutlist.AddLast(Blut.Create(x,y))
						Next
						If Typ=1 Then G.LP:-0.5
						If Typ=2 Then G.LP:-1
						If Typ=3 Then G.LP:-7.5
						If Typ=4 Then G.LP:-20
						If Typ=5 Then G.LP:-50
						Schusslist.Remove(Self)
						Exit
					EndIf
				Next
			EndIf
		EndIf
	End Method
	
	Method Draw()
		If x-ScrollX>-32 And x-ScrollX<WWidth+32 And y-ScrollY>-32 And y-ScrollY<WHeight+32 Then
			If Typ=1 Then
				SetColor 76,76,76
				DrawLine x-ScrollX,y-ScrollY,x+Sin(winkel)*3-ScrollX,y+Cos(winkel)*3-ScrollY
			ElseIf Typ=2 Then
				SetColor 50,50,50
				DrawLine x-ScrollX,y-ScrollY,x+Sin(winkel)*4-ScrollX,y+Cos(winkel)*4-ScrollY
			ElseIf Typ=3 Then
				SetColor 0,255,0
				DrawLine x-ScrollX,y-ScrollY,x+Sin(winkel)*4-ScrollX,y+Cos(winkel)*4-ScrollY
			ElseIf Typ=4 Then
				SetColor 255,0,0
				DrawOval x-ScrollX-2,y-ScrollY-2,4,4
			ElseIf Typ=5 Then
				SetColor 0,0,255
				DrawOval x-ScrollX-3,y-ScrollY-3,6,6
			EndIf
		EndIf
	End Method
	
	Function Create:Schuss(x:Float,y:Float,winkel:Int,spd:Float,Typ:Byte)
		Local S:Schuss=New Schuss
			S.x=x
			S.y=y
			S.winkel=winkel
			S.spd=spd
			S.Typ=Typ
		Return S
	End Function
End Type

'-----------------------------Blut------------------------------------
Type Blut
	Field x:Float,y:Float,xs:Float,ys:Float,rc:Byte,scale:Byte,Rotation:Int
	
	Method Update_Draw()
		ys:+0.5
		x:+xs
		y:+ys
		Rotation:+Rand(3)
		If x-ScrollX>-32 And x-ScrollX<WWidth+32 And y-ScrollY>-32 And y-ScrollY<WHeight+32 Then
			SetColor rc,0,0
			SetRotation Rotation
			DrawRect x-ScrollX,y-ScrollY,scale,scale
			SetRotation 0
		EndIf
		
		If x+xs<=0 Or x+xs>=(MapWidth)*32 Or y+ys<=0 Or y+ys>=(MapHeight)*32 Then 
			Blutlist.Remove(Self)
		Else
			If Map[Floor((x+xs)/32),Floor((y+ys)/32)]=1 Then Blutlist.Remove(Self)
		EndIf
	End Method
	
	Function Create:Blut(x:Float,y:Float)
		Local B:Blut=New Blut
		B.x=x
		B.y=y
		B.xs=Rand(-2.0,2.0)
		B.ys=Rand(-2.0,0.0)
		B.rc=Rand(128,200)
		B.scale=Rand(1,4)
		B.Rotation=Rand(0,360)
		Return B
	End Function
End Type

'------------------------- Kommandofelder -----------------------------
'Yep, mir fiel kein anderer Name ein. Siehe Funktion LoadKIMap, falls du wissen willst was das hier tut.
Type KIKommandoFeld
	Field x:Int,y:Int,w:Int,h:Int
	Field Kommando:Byte
	
	Function Create:KIKommandoFeld(x:Short,y:Short,w:Short,h:Short,Kommando:Byte)
		Local K:KIKommandoFeld=New KIKommandoFeld
		K.x=x*32
		K.y=y*32
		K.w=w*32
		K.h=h*32
		K.Kommando=Kommando
		Return K
	End Function
End Type
'=============================== INCLUDES ==============================
Include "Menue.bmx"
'=============================== VARIABELN =============================
'Bilder
Global Stickman:TImage=LoadAnimImage("gfx\Gegner.png",32,48,0,8)
Global StickmanR:TImage=LoadAnimImage("gfx\GegnerR.png",32,48,0,8)
AutoMidHandle 1
Global G1:TImage=LoadImage("gfx\Tower\Geschuetz1.png")
Global G2:TImage=LoadImage("gfx\Tower\Geschuetz2.png")
Global G3:TImage=LoadImage("gfx\Tower\Geschuetz3.png")
Global G4:TImage=LoadImage("gfx\Tower\Geschuetz4.png")
Global G5:TImage=LoadImage("gfx\Tower\Geschuetz5.png")

'Spielvariabeln
Global Map:Byte [ , ]
Global MapWidth:Short,MapHeight:Short

Global ScrollX:Int,ScrollY:Int

Global Gegnerlist:TList
Global Kommandofeldlist:TList
Global Turmlist:TList
Global SchussList:TList
Global BlutList:TList

Global BloodOn:Byte

Global MapName:String
Global Geld:Int,Leben:Int,LAbEffekt:Byte,GAbEffekt:Byte
Global BauWahl:Byte=1,BauFreiSchalt:Byte=1,Menueoffen:Byte
Global Zeit:Int,Intervall:Short
Global Welle:Short=1,WT:Int
Global StickmanCount:Int,StickmanWave:Int=5
Global Msg:String,MsgTime:Int,MsgAlpha:Float
Global Pause:Byte,Beenden:Byte

'Allgemein
AppTitle = "Stickman - TowerDefense"
Global Timer:TTimer=CreateTimer(60)

Global H1:TimageFont = LoadImageFont("Fonts\Alexis 3D.ttf",100)
Global H2:TimageFont = LoadImageFont("Fonts\Alexis 3D.ttf",50)
Global Font:TimageFont=LoadImageFont("Fonts\Alexis 3D.ttf",25)

Global WWidth:Short,WHeight:Short,WMode:Byte

Local Datei:TStream=ReadFile("Config.cfg")
WWidth=ReadShort(Datei)
WHeight=ReadShort(Datei)
WMode=ReadByte(Datei)
BloodOn=ReadByte(Datei)
CloseFile Datei

Global Ende:Byte

'=============================== SPIEL INITIALISIEREN =============================
Graphics WWidth,WHeight,WMode,0

SeedRnd(MilliSecs())

SetBlend ALPHABLEND
Repeat
	SetClsColor 0,0,0
	Menue()

	SetImageFont(Font)

	SetClsColor 200,200,200

	'=============================== HAUPTSCHLEIFE =============================
	If Auswahl=1 Then
		Message("Ready for "+MapName+"?",2000)
		Repeat
			Cls
			If Pause=0 Then
				UpdateGegner()
				UpdateTuerme()
				UpdateSchuesse()
				UpdateWellen()
				
				ScrollMap()
				ControlBauen()
			EndIf
			
			DrawMap()
			DrawTuerme()
			DrawSchuesse()
			DrawGegner()
			If BloodOn=1 And Pause=0 Then Blood()
			DrawAnzeige()
			If Pause=0 Then
				UpdateMessage()
				BauMenue()
			EndIf
			
			If Pause=1 Then PauseMenue()
			
			If KeyHit(KEY_Escape) Then
				If Pause=0 Then
					Pause=1
				Else
					Pause=0
				EndIf
			EndIf
			If AppTerminate() Then Ende=1
			Flip 0
			WaitTimer Timer
		Until Ende=1 Or Leben<=0 Or Beenden=1
		SetClsColor 0,0,0
		If Leben<=0 Then GameOver()
		Auswahl=0
		Beenden=0
		Pause=0
	EndIf
Until Auswahl=3 Or Ende=1

End

'=============================== FUNKTIONEN =============================

'Map laden
Function LoadMap(MapURL:String)
	Gegnerlist:TList=New TList
	Turmlist:TList=New TList
	SchussList:TList=New TList
	BlutList:TList=New TList
	StickmanCount=0
	BauWahl=1
	BauFreiSchalt=1
	Welle=1
	StickmanWave=5
	Local MapPix:TPixmap
	Local ix:Short,iy:Short
	MapPix=LoadPixmap(MapURL+".png")
	MapWidth=PixmapWidth(MapPix)-1
	MapHeight=PixmapHeight(MapPix)-1
	
	Map=New Byte[MapWidth+1,MapHeight+1]
	
	For ix=0 To MapWidth
		For iy=0 To MapHeight
			Select ReadPixel(MapPix,ix,iy)
				Case -16777216
					Map[ix,iy]=1
				Case -16711936
					Map[ix,iy]=2
				Case -65536
					Map[ix,iy]=3
			End Select
		Next
	Next
	LoadMapDat(MapURL)
End Function

'Mapdaten und KI Map laden... Die KI-Map besteht aus verschieden groen Rechtecken auf der Karte, die, wenn von einem Strichmnnchen berhrt, ihm sagen sollen, was er tun soll...
Function LoadMapDat(MapURL:String)
	Local Datei:TStream
	Local K:KIKommandoFeld
	KommandoFeldList=New TList
	Datei=ReadFile(MapURL+".Map")
	
	'Mapdaten
	Geld=ReadInt(Datei)
	Leben=15
	Zeit=ReadShort(Datei)
	Intervall=ReadShort(Datei)
	
	'KI-Map
	Local x:Short,y:Short,w:Short,h:Short,Kommando:Byte
	Repeat
		x=ReadShort(Datei)
		y=ReadShort(Datei)
		w=ReadShort(Datei)
		h=ReadShort(Datei)
		Kommando=ReadByte(Datei)
		KommandoFeldList.AddLast(KIKommandoFeld.Create(x,y,w,h,Kommando))
	Until Eof(Datei)
	CloseFile Datei
End Function

'Gegner updaten
Function UpdateGegner()
	For Local G:Gegner=EachIn Gegnerlist
		G.Update()
	Next
End Function

'Tuerme updaten
Function UpdateTuerme()
	For Local T:Turm=EachIn Turmlist
		T.Update()
	Next
End Function

'Schuesse updaten
Function UpdateSchuesse()
	For Local S:Schuss=EachIn Schusslist
		S.Update()
	Next
End Function

'Wellen updaten
Function UpdateWellen()
	If WT<MilliSecs() And Zeit>0 Then
		WT=MilliSecs()+1000
		Zeit:-1
	EndIf
	
	If Zeit<1 Then
		If StickmanCount<StickmanWave And WT<MilliSecs() Then
			WT=MilliSecs()+Rand(0,100)
			Gegnerlist.AddLast(Gegner.Create(0,192,Welle/2))
			StickmanCount:+1
		Else
			If ListIsEmpty(Gegnerlist) And StickmanCount>=StickmanWave Then
				StickmanCount=0
				Zeit=Intervall
				StickmanWave=Floor(5+5*Welle)
				Geld:+Welle*50
				Message(Welle*50+" Geldbonus erhalten",3000)
				If Welle=5 Or Welle=10 Or Welle=15 Or Welle=20 Then 
					BauFreischalt:+1
					Zeit:+15
					Message("Neues Geschuetz freigeschaltet und "+Welle*50+" Geldbonus erhalten",5000)
				EndIf
				Welle:+1
			EndIf
		EndIf
	EndIf
End Function

'Messagefunktion
Function Message(Str:String,iZeit:Int)
	Msg=Str
	MsgTime=MilliSecs()+iZeit
	MsgAlpha=1
End Function

'Messages updaten
Function UpdateMessage()
	If Msg<>"" Then
		SetColor 25,25,25
		SetAlpha MsgAlpha
		DrawRect 0,WHeight/2-50,WWidth,100
		SetColor 255,255,255
		DrawText Msg,WWidth/2-TextWidth(Msg)/2,WHeight/2
		SetAlpha 1
		If MsgTime<MilliSecs() Then
			MsgTime=MilliSecs()+50
			MsgAlpha:-0.05
			If MsgAlpha<=0 Then Msg=""
		EndIf 
	EndIf
End Function

'Map scrollen mit WASD oder den Pfeiltasten
Function ScrollMap()
	If (KeyDown(KEY_W) Or KeyDown(KEY_Up)) And ScrollY>-100 Then ScrollY=ScrollY-5
	If (KeyDown(KEY_S) Or KeyDown(KEY_Down)) And ScrollY<(MapHeight+1)*32-WHeight-2 Then ScrollY=ScrollY+5
	If (KeyDown(KEY_A) Or KeyDown(KEY_Left)) And ScrollX>0 Then ScrollX=ScrollX-5
	If (KeyDown(KEY_D) Or KeyDown(KEY_Right)) And ScrollX<(MapWidth+1)*32-WWidth-2 Then ScrollX=ScrollX+5
End Function

'Bauen
Function ControlBauen()
	Local Besetzt
	If MouseY()>125 And MenueOffen=0 Then
		Local mx=Floor((MouseX()+ScrollX)/32)*32
		Local my=Floor((MouseY()+ScrollY)/32)*32
		For Local T:Turm=EachIn Turmlist
			If T.x=mx And T.y=my And T.Typ>=BauWahl Then 
				Besetzt=1
				Exit
			EndIf
		Next
		If Besetzt=1 Then
			SetColor 255,0,0
		Else
			SetColor 0,255,0
		EndIf
		DrawRect mx-ScrollX,my-ScrollY,32,32
		
		If MouseHit(1) And Map[mx/32,my/32]=0 And Besetzt=0 Then
			Local Cost:Short
			If Bauwahl=1 Then Cost=100
			If Bauwahl=2 Then Cost=150
			If Bauwahl=3 Then Cost=300
			If Bauwahl=4 Then Cost=500
			If Bauwahl=5 Then Cost=1000
			If Geld>=Cost Then
				Geld:-Cost
				For Local T:Turm=EachIn Turmlist
					If T.x=mx And T.y=my Then
						If T.Typ=1 Then Geld:+50
						If T.Typ=2 Then Geld:+75
						If T.Typ=3 Then Geld:+150
						If T.Typ=4 Then Geld:+250
						If T.Typ=5 Then Geld:+500
						Turmlist.Remove(T)
					EndIf
				Next
				Turmlist.Addlast(Turm.Create(mx,my,BauWahl))
				GAbEffekt=255
			Else
				Message("Nicht genug Geld",0)
			EndIf
		EndIf
	EndIf
End Function

'Map zeichnen
Function DrawMap()
	Local ix:Short,iy:Short
	For ix=0 To MapWidth
		For iy=0 To MapHeight
			Select Map[ix,iy]
				Case 1
					SetColor 0,0,0
					DrawRect ix*32-ScrollX,iy*32-ScrollY,32,32
				Case 2
					SetColor 0,128,0
					DrawRect ix*32-ScrollX,iy*32-ScrollY,32,32
				Case 3
					SetColor 128,0,0
					DrawRect ix*32-ScrollX,iy*32-ScrollY,32,32
			End Select
		Next
	Next
End Function

'Tuerme zeichnen
Function DrawTuerme()
	For Local T:Turm=EachIn Turmlist
		T.Draw()
	Next
End Function

'Schuesse zeichnen
Function DrawSchuesse()
	For Local S:Schuss=EachIn Schusslist
		S.Draw()
	Next
End Function

'Gegner zeichnen
Function DrawGegner()
	For Local G:Gegner=EachIn Gegnerlist
		G.Draw()
	Next
End Function

'Blut zeichnen und update()
Function Blood()
	For Local B:Blut=EachIn Blutlist
		B.Update_Draw()
	Next
End Function

'Anzeige zeichnen
Function DrawAnzeige()
	'Hintergrund
	SetColor 76,76,76
	DrawRect 0,0,WWidth,100
	'Abtrennung von Spielfeld
	SetColor 25,25,25
	DrawRect 0,100,WWidth,25
	'LevelNameHintergrund
	DrawRect 0,0,100,20
	'GeldHintergrund
	DrawRect 25,30,150,50
	'WellenanzeigeHintergrund
	DrawRect 200,30,275,50
	'BauMenueHintergrund
	DrawRect 500,30,75,50
	'LebenHintergrund
	DrawRect WWidth-125,30,100,50
	
	'LevelNameText
	SetColor 255,255,255
	DrawText MapName,5,2
	'GeldText mit Geldabzugeffekt
	If GAbEffekt>0 Then GAbEffekt:-5
	SetColor 255,255-GAbEffekt,255-GAbEffekt
	DrawText "GELD:",30,35
	DrawText Geld+"$",30,60
	'WellenanzeigeText mit Schnem Blinken bei geringer Zeit. Die Mnnchenanzeige wird nach der Schwierigkeit der Mnnchen eingefrbt
	SetColor 255,255,255
	If Zeit<=10 Then SetColor 255-Sin(MilliSecs())*50,0,0
	DrawText Welle+". Welle in: "+Zeit+" sek",205,35
	SetScale 0.5,0.5
	If Floor(Welle/2.5)<=50 Then
		SetColor Floor(Welle/2.5)*25.5,255-Floor(Welle/2.5)*25.5,0
	Else
		SetColor 255,0,0
	EndIf
	DrawImage Stickman,205,55,1
	SetColor 255,255,255
	SetScale 1,1
	DrawText ": "+CountList(GegnerList)+"/"+StickmanWave,220,60
	'BauMenueanzeige mit tollem Bild und Kostenanzeige
	Select BauWahl
		Case 1
			DrawImage G1,525,45
			DrawText "100$",505,60
		Case 2
			DrawImage G2,525,45
			DrawText "150$",505,60
		Case 3
			DrawImage G3,525,45
			DrawText "300$",505,60
		Case 4
			DrawImage G4,525,45
			DrawText "500$",505,60
		Case 5
			DrawImage G5,525,45
			DrawText "1000$",505,60
	End Select
	SetAlpha 0.25
	SetColor 0,255,0
	If MouseX()>500 And MouseY()>30 And MouseX()<575 And MouseY()<80 And MenueOffen=0 Then DrawRect 500,30,75,50
	SetAlpha 1
	SetColor 255,255,255
	'Lebensanzeige mit Lebensabzugeffekt
	If LAbEffekt>0 Then LAbEffekt:-5
	SetColor 255,255-LAbEffekt,255-LAbEffekt
	DrawText "LEBEN:",WWidth-120,35
	DrawText Leben,WWidth-120,60
End Function

'BauMenue
Function BauMenue()
	If MouseY()<125 And MenueOffen=0 Then
		If MouseHit(1) Then
			If MouseX()>500 And MouseY()>30 And MouseX()<575 And MouseY()<80 Then 
				MenueOffen=1
			EndIf
		EndIf
	EndIf
	
	If MenueOffen=1 Then
		If MouseHit(1) Then MenueOffen=0
		If MouseX()>495 And MouseX()<775 And MouseY()>30 And MouseY()<30+50+50*BauFreischalt Then
			SetColor 96,96,96
			DrawRect 495,80,280,BauFreischalt*50
					
			'1.Geschuetz
			SetColor 30,30,30
			DrawRect 500,85,270,40
			SetColor 255,255,255
			DrawText "Leichtes MG:",505,85
			DrawText "100$",540,110
			DrawImage G1,525,110
				
			'2.Geschuetz
			If BauFreischalt>1 Then
				SetColor 30,30,30
				DrawRect 500,130,270,40
				SetColor 255,255,255
				DrawText "Doppeltes MG:",505,130
				DrawText "150$",540,155
				DrawImage G2,525,155
			EndIf
			
			'3.Geschuetz
			If BauFreischalt>2 Then
				SetColor 30,30,30
				DrawRect 500,175,270,40
				SetColor 255,255,255
				DrawText "1. Gen. Laser:",505,175
				DrawText "300$",540,200
				DrawImage G3,525,200
			EndIf
			
			'4.Geschuetz
			If BauFreischalt>3 Then
				SetColor 30,30,30
				DrawRect 500,220,270,40
				SetColor 255,255,255
				DrawText "2. Gen. Laser:",505,220
				DrawText "500$",540,245
				DrawImage G4,525,245
			EndIf
			
			'5.Geschuetz
			If BauFreischalt>4 Then
				SetColor 30,30,30
				DrawRect 500,265,270,40
				SetColor 255,255,255
				DrawText "OMFG Laser:",505,265
				DrawText "1000$",540,280
				DrawImage G5,525,280
			EndIf
			
			SetAlpha 0.25
			SetColor 0,255,0
			If MouseY()>80 Then DrawRect 500,Floor((MouseY()-30)/50)*50+30+5-5*(Floor((MouseY()-30)/50)-1),270,40
			BauWahl=Floor((MouseY()-30)/50)
			SetAlpha 1
		Else
			MenueOffen=0
		EndIf
	EndIf
End Function

'Rectsoverlap funktion
Function RectsOverlap(x0:Int, y0:Int, w0:Short, h0:Short, x2:Int, y2:Int, w2:Short, h2:Short)
    If x0 > (x2 + w2) Or (x0 + w0) < x2 Then Return False
    If y0 > (y2 + h2) Or (y0 + h0) < y2 Then Return False
    Return True
End Function